// Copyright (C) 2012-2013 ChaosForge / Kornel Kisielewicz
// http://chaosforge.org/
//
// This file is part of NV Libraries.
// For conditions of distribution and use, see copyright notice in nv.hh
/**
 * @file gl_texture2d.hh
 * @author Kornel Kisielewicz epyon@chaosforge.org
 * @brief Texture2D class
 */

#ifndef NV_GL_TEXTURE2D_HH
#define NV_GL_TEXTURE2D_HH

#include <nv/interface/texture2d.hh>

namespace nv
{

	class gl_texture2d : public texture2d
	{
	public:
		friend class gl_context;

		gl_texture2d( ivec2 size, pixel_format aformat, datatype adatatype, sampler asampler, void* data = nullptr );
		~gl_texture2d();
	protected:
		unsigned glid;
	};
	
} // namespace nv

#endif // NV_GL_TEXTURE2D_HH
