// Copyright (C) 2012-2013 ChaosForge / Kornel Kisielewicz
// http://chaosforge.org/
//
// This file is part of NV Libraries.
// For conditions of distribution and use, see copyright notice in nv.hh
/**
 * @file gl_vertex_buffer.hh
 * @author Kornel Kisielewicz epyon@chaosforge.org
 * @brief Vertex buffer implementation
 */

#ifndef NV_GL_VERTEX_BUFFER_HH
#define NV_GL_VERTEX_BUFFER_HH

#include <nv/interface/vertex_buffer.hh>

namespace nv
{

	class gl_vertex_buffer : public vertex_buffer
	{
	public:
		friend class gl_context;

		gl_vertex_buffer( buffer_hint hint, size_t size, const void* data = nullptr );
		~gl_vertex_buffer();
	private:
		unsigned glid;
	};

	class gl_index_buffer : public index_buffer
	{
	public:
		friend class gl_context;

		gl_index_buffer( buffer_hint hint, size_t size, const void* data = nullptr );
		~gl_index_buffer();
	private:
		unsigned glid;
	};

} // namespace nv

#endif // NV_GL_VERTEX_BUFFER_HH
